module Factorial
open Heap
open ST


val factorial_tot : x : nat -> Tot nat
let rec factorial_tot x = if x = 0 then 1 else x * factorial_tot (x - 1)

val factorial : r1:ref nat -> r2:ref nat -> St unit
      (requires (fun h0 -> contains h0 r1 /\ contains h0 r2 /\ r1 <> r2))
      (ensures (fun h0 a h1 -> exists x.
                equal h1 (upd (upd h0 r1 x) r2 (factorial_tot (sel h0 r1)))))
let rec factorial r1 r2 =
  let tmp = read r1 in
  if tmp = 0
  then write r2 1
  else 
    (write r1 (tmp - 1);
     factorial r1 r2;
     write r2 (read r2 * tmp))
